package org.jvnet.hifaces.binding;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.MethodNotFoundException;
import javax.faces.el.PropertyNotFoundException;

public abstract class RequestMethodBinding extends MethodBinding {
  
  private final String var;

  public RequestMethodBinding(String var) {
    this.var = var;
  }

  public Object invoke(FacesContext facesContext, Object[] arguments)
      throws EvaluationException,
      MethodNotFoundException {
    final Object value = facesContext.getExternalContext().getRequestMap().get(var);
    return invoke(value);
  }

  public abstract Object invoke(Object var);

  public Class getType(FacesContext facesContext)
      throws EvaluationException,
      PropertyNotFoundException {
    return Object.class;
  }

}
