package org.jvnet.hifaces.event;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import javax.faces.component.UIComponent;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TestPhaseListener implements PhaseListener {

	private Log logger = LogFactory.getLog(getClass());

	public void afterPhase(PhaseEvent event) {
	}

	public void beforePhase(PhaseEvent event) {

		final UIComponent c = event.getFacesContext().getViewRoot();
		int i = 0;

		final Map s = new HashMap();
		i = traverse(c, i, s, "");
		System.out.println(s.size());
		System.out.println(i);
	}

	private int traverse(final UIComponent c, int a, Map s, String path) {
		int i = a;
		UIComponent d, e;
		if (c.getChildCount() > 0) {
			for (int index = 0; index < c.getChildren().size(); index++) {
				i++;
				d = (UIComponent) c.getChildren().get(index);
//				if (d.getFacets().size() > 0) {
//					for (Iterator jtr = d.getFacets().entrySet().iterator(); jtr
//							.hasNext();) {
//
//						final Entry entry = (Entry) jtr.next();
//						e = (UIComponent) entry.getValue();
//						System.out.println(i++);
//						System.out.println(e.getId());
//						final String facetPath = path + "/[" + index + "]/@"
//								+ entry.getKey();
//						check(s, e, facetPath);
//						s.put(e, facetPath);
//						i = traverse(e, i, s, facetPath);
//					}
//				}
				final String childPath = path + "/[" + index + "]";
				check(s, d, childPath);
				s.put(d, childPath);
				i = traverse(d, i, s, childPath);
			}
			for (Iterator itr = c.getChildren().iterator(); itr.hasNext();) {
				d = (UIComponent) itr.next();
			}
		}
		if (c.getFacets().size() > 0) {
			for (Iterator itr = c.getFacets().entrySet().iterator(); itr
					.hasNext();) {
				i++;
				final Map.Entry entry = (Entry) itr.next();
				d = (UIComponent) entry.getValue();

				final String facetPath = path + "/@" + entry.getKey();
				check(s, d, facetPath);
				s.put(d, facetPath);
				i = traverse(d, i, s, path + "/@" + entry.getKey());
			}
		}
		return i;
	}

	private void check(Map s, UIComponent e, final String facetPath) {
		final String oldFacetPath = (String) s.get(e);
		if (!(oldFacetPath == null)) {
			if (oldFacetPath.equals(facetPath)) {
				logger.warn("Component with id [" + e.getId()
						+ "] is found twice on the same path: [" + facetPath
						+ "].");
			} else {
				logger.warn("Component with id [" + e.getId()
						+ "] is found on two paths: [" + oldFacetPath
						+ "] and [" + facetPath + "].");
			}
		}
	}

	public PhaseId getPhaseId() {

		return PhaseId.RENDER_RESPONSE;
	}

}
