//Copyright (c) 2006 by disy Informationssysteme GmbH
package org.jvnet.hifaces.components.templatedpanel.impl;

import java.io.IOException;
import java.net.URI;

import javax.faces.context.FacesContext;

// NOT_PUBLISHED
public class URITemplateNameResolver implements TemplateNameResolver {

	private final URI baseURI;

	public URITemplateNameResolver(final URI baseURI) {
		super();
		this.baseURI = baseURI;
	}

	public TemplateResource resolve(FacesContext contex, String templateName)
			throws IOException {
		final URI uri = baseURI.resolve(templateName);
		return new URLTemplateResource(uri.toURL());
	}

}
