package org.jvnet.hifaces.model.paging;

import java.util.List;

/**
 * Default implementation of the data page.
 * 
 * @author valikov
 * 
 * @param <T>
 *            Type of the element.
 */

public class DefaultDataPage<T> extends AbstractDataPage<T> {

	private int count;

	public DefaultDataPage(int start, int count, List<T> data) {
		super(start, data);
		this.count = count;
	}

	public int getCount() {
		return count;
	}
}
